/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingCategoria;
import com.rjconsultores.ventaboletos.service.PricingCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingCategoriaService")
public class PricingCategoriaServiceImpl implements PricingCategoriaService {

    @Autowired
    private PricingCategoriaDAO pricingCategoriaDAO;

    public List<PricingCategoria> obtenerTodos() {
        return pricingCategoriaDAO.obtenerTodos();
    }

    public PricingCategoria obtenerID(Integer id) {
        return pricingCategoriaDAO.obtenerID(id);
    }

    @Transactional
    public PricingCategoria suscribir(PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingCategoriaDAO.suscribir(entidad);
    }

    @Transactional
    public PricingCategoria actualizacion(PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingCategoriaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.EXCLUIDO);

        pricingCategoriaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingCategoria(Pricing pricing, Categoria categoria) {
        return pricingCategoriaDAO.obtenerPricingCategoria(pricing, categoria);
    }

	@Override
	@Transactional
	public void borrar(List<PricingCategoria> pricingCategorias) {
		if(pricingCategorias != null && !pricingCategorias.isEmpty()) {
			for (PricingCategoria pricingCategoria : pricingCategorias) {
				borrar(pricingCategoria);
			}
		}
	}
}
